<?php
class GetStaffAppointments {
  public $Request; // GetStaffAppointmentsRequest
}

class GetStaffAppointmentsRequest {
  public $StaffCredentials; // StaffCredentials
  public $AppointmentIDs; // ArrayOfInt
  public $LocationIDs; // ArrayOfInt
  public $StartDate; // dateTime
  public $EndDate; // dateTime
  public $StaffIDs; // ArrayOfLong
  public $ClientIDs; // ArrayOfString
}

class MBRequest {
  public $SourceCredentials; // SourceCredentials
  public $UserCredentials; // UserCredentials
  public $XMLDetail; // XMLDetailLevel
  public $PageSize; // int
  public $CurrentPageIndex; // int
  public $Fields; // ArrayOfString
}

class SourceCredentials {
  public $SourceName; // string
  public $Password; // string
  public $SiteIDs; // ArrayOfInt
}

class UserCredentials {
  public $Username; // string
  public $Password; // string
  public $SiteIDs; // ArrayOfInt
}

class XMLDetailLevel {
  const Bare = 'Bare';
  const Basic = 'Basic';
  const Full = 'Full';
}

class StaffCredentials {
  public $Username; // string
  public $Password; // string
  public $SiteIDs; // ArrayOfInt
}

class GetStaffAppointmentsResponse {
  public $GetStaffAppointmentsResult; // GetStaffAppointmentsResult
}

class GetStaffAppointmentsResult {
  public $Appointments; // ArrayOfAppointment
}

class MBResult {
  public $Status; // StatusCode
  public $Message; // string
  public $XMLDetail; // XMLDetailLevel
  public $ResultCount; // int
  public $CurrentPageIndex; // int
  public $TotalPageCount; // int
}

class StatusCode {
  const Success = 'Success';
  const InvalidCredentials = 'InvalidCredentials';
  const InvalidParameters = 'InvalidParameters';
  const InternalException = 'InternalException';
  const Unknown = 'Unknown';
  const FailedAction = 'FailedAction';
}

class Appointment {
  public $Action; // ActionCode
  public $ID; // long
  public $Status; // AppointmentStatus
  public $StartDateTime; // dateTime
  public $EndDateTime; // dateTime
  public $Notes; // string
  public $StaffRequested; // boolean
  public $Program; // Program
  public $SessionType; // SessionType
  public $Location; // Location
  public $Staff; // Staff
  public $Client; // Client
  public $FirstAppointment; // boolean
  public $ClientService; // ClientService
  public $Resources; // ArrayOfResource
}

class ScheduleItem {
}

class MBObject {
  public $Site; // Site
  public $Messages; // ArrayOfString
  public $Execute; // string
}

class Site {
  public $ID; // int
  public $Name; // string
  public $LogoURL; // string
  public $PageColor1; // string
  public $PageColor2; // string
  public $PageColor3; // string
  public $PageColor4; // string
}

class Resource {
  public $Action; // ActionCode
  public $ID; // int
  public $Name; // string
}

class ActionCode {
  const None = 'None';
  const Added = 'Added';
  const Updated = 'Updated';
  const Failed = 'Failed';
}

class ClientService {
  public $Action; // ActionCode
  public $ID; // long
  public $Name; // string
  public $PaymentDate; // dateTime
  public $ActiveDate; // dateTime
  public $ExpirationDate; // dateTime
  public $Program; // Program
}

class Program {
  public $ID; // int
  public $Name; // string
  public $ScheduleType; // ScheduleType
}

class ScheduleType {
  const All = 'All';
  const DropIn = 'DropIn';
  const Enrollment = 'Enrollment';
  const Appointment = 'Appointment';
  const Resource = 'Resource';
  const Media = 'Media';
  const Arrival = 'Arrival';
}

class ClientRelationship {
  public $RelatedClient; // Client
  public $Relationship; // Relationship
  public $RelationshipName; // string
}

class Client {
  public $NewID; // string
  public $AccountBalance; // double
  public $ClientIndexes; // ArrayOfClientIndex
  public $Username; // string
  public $Password; // string
  public $Notes; // string
  public $ClientCreditCards; // ArrayOfClientCreditCard
  public $LastFormulaNotes; // string
  public $AppointmentGenderPreference; // string
  public $Gender; // string
  public $IsCompany; // boolean
  public $ClientRelationships; // ArrayOfClientRelationship
  public $CustomClientFields; // ArrayOfCustomClientField
  public $Action; // ActionCode
  public $ID; // string
  public $FirstName; // string
  public $MiddleName; // string
  public $LastName; // string
  public $Email; // string
  public $EmailOptIn; // boolean
  public $AddressLine1; // string
  public $AddressLine2; // string
  public $City; // string
  public $State; // string
  public $PostalCode; // string
  public $Country; // string
  public $MobilePhone; // string
  public $HomePhone; // string
  public $WorkPhone; // string
  public $WorkExtension; // string
  public $BirthDate; // dateTime
  public $FirstAppointmentDate; // dateTime
  public $ReferredBy; // string
  public $HomeLocation; // Location
  public $YellowAlert; // string
  public $RedAlert; // string
  public $PhotoURL; // string
  public $IsProspect; // boolean
}

class ClientIndex {
  public $Action; // ActionCode
  public $ID; // int
  public $Name; // string
  public $Values; // ArrayOfClientIndexValue
}

class ClientIndexValue {
  public $Action; // ActionCode
  public $ID; // int
  public $Name; // string
}

class ClientCreditCard {
  public $CardType; // string
  public $LastFour; // string
  public $CardHolder; // string
  public $ExpMonth; // string
  public $ExpYear; // string
  public $Address; // string
  public $PostalCode; // string
}

class CustomClientField {
  public $ID; // int
  public $DataType; // string
  public $Name; // string
  public $Value; // string
}

class Location {
  public $BusinessID; // int
  public $SiteID; // int
  public $AdditionalImageURLs; // ArrayOfString
  public $FacilitySquareFeet; // int
  public $TreatmentRooms; // int
  public $ProSpaFinderSite; // boolean
  public $Action; // ActionCode
  public $ID; // int
  public $Name; // string
  public $Address; // string
  public $Address2; // string
  public $Tax1; // float
  public $Tax2; // float
  public $Tax3; // float
  public $Tax4; // float
  public $Tax5; // float
  public $Phone; // string
  public $City; // string
  public $StateProvCode; // string
  public $PostalCode; // string
  public $Latitude; // double
  public $Longitude; // double
  public $DistanceInMiles; // double
  public $ImageURL; // string
  public $Description; // string
  public $HasSite; // boolean
  public $CanBook; // boolean
}

class Relationship {
  public $ID; // int
  public $RelationshipName1; // string
  public $RelationshipName2; // string
}

class SessionType {
  public $Action; // ActionCode
  public $ID; // int
  public $Name; // string
}

class Staff {
  public $Appointments; // ArrayOfAppointment
  public $Unavailabilities; // ArrayOfUnavailability
  public $Availabilities; // ArrayOfAvailability
  public $Action; // ActionCode
  public $ID; // long
  public $Name; // string
  public $FirstName; // string
  public $LastName; // string
  public $ImageURL; // string
  public $Bio; // string
  public $isMale; // boolean
}

class Unavailability {
  public $ID; // int
  public $StartDateTime; // dateTime
  public $EndDateTime; // dateTime
  public $Description; // string
}

class Availability {
  public $ID; // int
  public $Staff; // Staff
  public $SessionType; // SessionType
  public $Programs; // ArrayOfProgram
  public $StartDateTime; // dateTime
  public $EndDateTime; // dateTime
  public $BookableEndDateTime; // dateTime
  public $Location; // Location
}

class AppointmentStatus {
  const Booked = 'Booked';
  const Completed = 'Completed';
  const Confirmed = 'Confirmed';
  const Arrived = 'Arrived';
  const NoShow = 'NoShow';
}

class AddOrUpdateAppointments {
  public $Request; // AddOrUpdateAppointmentsRequest
}

class AddOrUpdateAppointmentsRequest {
  public $UpdateAction; // string
  public $Test; // boolean
  public $Appointments; // ArrayOfAppointment
}

class AddOrUpdateAppointmentsResponse {
  public $AddOrUpdateAppointmentsResult; // AddOrUpdateAppointmentsResult
}

class AddOrUpdateAppointmentsResult {
  public $Appointments; // ArrayOfAppointment
}

class GetBookableItems {
  public $Request; // GetBookableItemsRequest
}

class GetBookableItemsRequest {
  public $SessionTypeIDs; // ArrayOfInt
  public $LocationIDs; // ArrayOfInt
  public $StaffIDs; // ArrayOfLong
  public $StartDate; // dateTime
  public $EndDate; // dateTime
}

class GetBookableItemsResponse {
  public $GetBookableItemsResult; // GetBookableItemsResult
}

class GetBookableItemsResult {
  public $ScheduleItems; // ArrayOfScheduleItem
}

class GetScheduleItems {
  public $Request; // GetScheduleItemsRequest
}

class GetScheduleItemsRequest {
  public $LocationIDs; // ArrayOfInt
  public $StaffIDs; // ArrayOfLong
  public $StartDate; // dateTime
  public $EndDate; // dateTime
}

class GetScheduleItemsResponse {
  public $GetScheduleItemsResult; // GetScheduleItemsResult
}

class GetScheduleItemsResult {
  public $StaffMembers; // ArrayOfStaff
}

class AddOrUpdateAvailabilities {
  public $Request; // AddOrUpdateAvailabilitiesRequest
}

class AddOrUpdateAvailabilitiesRequest {
  public $UpdateAction; // string
  public $Test; // boolean
  public $AvailabilityIDs; // ArrayOfInt
  public $LocationID; // int
  public $StaffIDs; // ArrayOfLong
  public $ProgramIDs; // ArrayOfInt
  public $StartDateTime; // dateTime
  public $EndDateTime; // dateTime
  public $DaysOfWeek; // ArrayOfDayOfWeek
  public $UnavailableDescription; // string
  public $IsUnavailable; // boolean
  public $PublicDisplay; // AvailabilityDisplay
}

class DayOfWeek {
  const Sunday = 'Sunday';
  const Monday = 'Monday';
  const Tuesday = 'Tuesday';
  const Wednesday = 'Wednesday';
  const Thursday = 'Thursday';
  const Friday = 'Friday';
  const Saturday = 'Saturday';
}

class AvailabilityDisplay {
  const Hide = 'Hide';
  const Show = 'Show';
  const Mask = 'Mask';
}

class AddOrUpdateAvailabilitiesResponse {
  public $AddOrUpdateAvailabilitiesResult; // AddOrUpdateAvailabilitiesResult
}

class AddOrUpdateAvailabilitiesResult {
  public $StaffMembers; // ArrayOfStaff
}

class GetActiveSessionTimes {
  public $Request; // GetActiveSessionTimesRequest
}

class GetActiveSessionTimesRequest {
  public $ScheduleType; // ScheduleType
  public $StartTime; // dateTime
  public $EndTime; // dateTime
}

class GetActiveSessionTimesResponse {
  public $GetActiveSessionTimesResult; // GetActiveSessionTimesResult
}

class GetActiveSessionTimesResult {
  public $Times; // ArrayOfDateTime
}

class GetAppointmentOptions {
  public $Request; // GetAppointmentOptionsRequest
}

class GetAppointmentOptionsRequest {
}

class GetAppointmentOptionsResponse {
  public $GetAppointmentOptionsResult; // GetAppointmentOptionsResult
}

class GetAppointmentOptionsResult {
  public $Options; // ArrayOfOption
}

class Option {
  public $DisplayName; // string
  public $Name; // string
  public $Value; // string
  public $Type; // string
}


/**
 * Appointment_x0020_Service class
 * 
 * Provides methods and attributes relating to appointments.
 * 
 * @author    {author}
 * @copyright {copyright}
 * @package   {package}
 */
class Appointment_x0020_Service extends SoapClient {

  private static $classmap = array(
                                    'GetStaffAppointments' => 'GetStaffAppointments',
                                    'GetStaffAppointmentsRequest' => 'GetStaffAppointmentsRequest',
                                    'MBRequest' => 'MBRequest',
                                    'SourceCredentials' => 'SourceCredentials',
                                    'UserCredentials' => 'UserCredentials',
                                    'XMLDetailLevel' => 'XMLDetailLevel',
                                    'StaffCredentials' => 'StaffCredentials',
                                    'GetStaffAppointmentsResponse' => 'GetStaffAppointmentsResponse',
                                    'GetStaffAppointmentsResult' => 'GetStaffAppointmentsResult',
                                    'MBResult' => 'MBResult',
                                    'StatusCode' => 'StatusCode',
                                    'Appointment' => 'Appointment',
                                    'ScheduleItem' => 'ScheduleItem',
                                    'MBObject' => 'MBObject',
                                    'Site' => 'Site',
                                    'Resource' => 'Resource',
                                    'ActionCode' => 'ActionCode',
                                    'ClientService' => 'ClientService',
                                    'Program' => 'Program',
                                    'ScheduleType' => 'ScheduleType',
                                    'ClientRelationship' => 'ClientRelationship',
                                    'Client' => 'Client',
                                    'ClientIndex' => 'ClientIndex',
                                    'ClientIndexValue' => 'ClientIndexValue',
                                    'ClientCreditCard' => 'ClientCreditCard',
                                    'CustomClientField' => 'CustomClientField',
                                    'Location' => 'Location',
                                    'Relationship' => 'Relationship',
                                    'SessionType' => 'SessionType',
                                    'Staff' => 'Staff',
                                    'Unavailability' => 'Unavailability',
                                    'Availability' => 'Availability',
                                    'AppointmentStatus' => 'AppointmentStatus',
                                    'AddOrUpdateAppointments' => 'AddOrUpdateAppointments',
                                    'AddOrUpdateAppointmentsRequest' => 'AddOrUpdateAppointmentsRequest',
                                    'AddOrUpdateAppointmentsResponse' => 'AddOrUpdateAppointmentsResponse',
                                    'AddOrUpdateAppointmentsResult' => 'AddOrUpdateAppointmentsResult',
                                    'GetBookableItems' => 'GetBookableItems',
                                    'GetBookableItemsRequest' => 'GetBookableItemsRequest',
                                    'GetBookableItemsResponse' => 'GetBookableItemsResponse',
                                    'GetBookableItemsResult' => 'GetBookableItemsResult',
                                    'GetScheduleItems' => 'GetScheduleItems',
                                    'GetScheduleItemsRequest' => 'GetScheduleItemsRequest',
                                    'GetScheduleItemsResponse' => 'GetScheduleItemsResponse',
                                    'GetScheduleItemsResult' => 'GetScheduleItemsResult',
                                    'AddOrUpdateAvailabilities' => 'AddOrUpdateAvailabilities',
                                    'AddOrUpdateAvailabilitiesRequest' => 'AddOrUpdateAvailabilitiesRequest',
                                    'DayOfWeek' => 'DayOfWeek',
                                    'AvailabilityDisplay' => 'AvailabilityDisplay',
                                    'AddOrUpdateAvailabilitiesResponse' => 'AddOrUpdateAvailabilitiesResponse',
                                    'AddOrUpdateAvailabilitiesResult' => 'AddOrUpdateAvailabilitiesResult',
                                    'GetActiveSessionTimes' => 'GetActiveSessionTimes',
                                    'GetActiveSessionTimesRequest' => 'GetActiveSessionTimesRequest',
                                    'GetActiveSessionTimesResponse' => 'GetActiveSessionTimesResponse',
                                    'GetActiveSessionTimesResult' => 'GetActiveSessionTimesResult',
                                    'GetAppointmentOptions' => 'GetAppointmentOptions',
                                    'GetAppointmentOptionsRequest' => 'GetAppointmentOptionsRequest',
                                    'GetAppointmentOptionsResponse' => 'GetAppointmentOptionsResponse',
                                    'GetAppointmentOptionsResult' => 'GetAppointmentOptionsResult',
                                    'Option' => 'Option',
                                   );

  public function Appointment_x0020_Service($wsdl = "http://clients.mindbodyonline.com/api/0_5/AppointmentService.asmx?WSDL", $options = array()) {
    foreach(self::$classmap as $key => $value) {
      if(!isset($options['classmap'][$key])) {
        $options['classmap'][$key] = $value;
      }
    }
    parent::__construct($wsdl, $options);
  }

  /**
   * Gets a list of appointments that a given staff memeber is instructing.
   *
   * @param GetStaffAppointments $parameters
   * @return GetStaffAppointmentsResponse
   */
  public function GetStaffAppointments(GetStaffAppointments $parameters) {
    return $this->__soapCall('GetStaffAppointments', array($parameters),       array(
            'uri' => 'http://clients.mindbodyonline.com/api/0_5',
            'soapaction' => ''
           )
      );
  }

  /**
   * Adds or updates a list of appointments.
   *
   * @param AddOrUpdateAppointments $parameters
   * @return AddOrUpdateAppointmentsResponse
   */
  public function AddOrUpdateAppointments(AddOrUpdateAppointments $parameters) {
    return $this->__soapCall('AddOrUpdateAppointments', array($parameters),       array(
            'uri' => 'http://clients.mindbodyonline.com/api/0_5',
            'soapaction' => ''
           )
      );
  }

  /**
   * Gets a list of bookable items.
   *
   * @param GetBookableItems $parameters
   * @return GetBookableItemsResponse
   */
  public function GetBookableItems(GetBookableItems $parameters) {
    return $this->__soapCall('GetBookableItems', array($parameters),       array(
            'uri' => 'http://clients.mindbodyonline.com/api/0_5',
            'soapaction' => ''
           )
      );
  }

  /**
   * Gets a list of scheduled items (appointments, availabilities, and unavailabilities).
   *
   * @param GetScheduleItems $parameters
   * @return GetScheduleItemsResponse
   */
  public function GetScheduleItems(GetScheduleItems $parameters) {
    return $this->__soapCall('GetScheduleItems', array($parameters),       array(
            'uri' => 'http://clients.mindbodyonline.com/api/0_5',
            'soapaction' => ''
           )
      );
  }

  /**
   * Adds or updates a list of availabilities.
   *
   * @param AddOrUpdateAvailabilities $parameters
   * @return AddOrUpdateAvailabilitiesResponse
   */
  public function AddOrUpdateAvailabilities(AddOrUpdateAvailabilities $parameters) {
    return $this->__soapCall('AddOrUpdateAvailabilities', array($parameters),       array(
            'uri' => 'http://clients.mindbodyonline.com/api/0_5',
            'soapaction' => ''
           )
      );
  }

  /**
   * Gets a list of times that are active for a given program ID.
   *
   * @param GetActiveSessionTimes $parameters
   * @return GetActiveSessionTimesResponse
   */
  public function GetActiveSessionTimes(GetActiveSessionTimes $parameters) {
    return $this->__soapCall('GetActiveSessionTimes', array($parameters),       array(
            'uri' => 'http://clients.mindbodyonline.com/api/0_5',
            'soapaction' => ''
           )
      );
  }

  /**
   * Gets a list appointment options.
   *
   * @param GetAppointmentOptions $parameters
   * @return GetAppointmentOptionsResponse
   */
  public function GetAppointmentOptions(GetAppointmentOptions $parameters) {
    return $this->__soapCall('GetAppointmentOptions', array($parameters),       array(
            'uri' => 'http://clients.mindbodyonline.com/api/0_5',
            'soapaction' => ''
           )
      );
  }

}

?>
