<?php
// Load the classes constructed by wsdl2php
require_once './Appointment_x0020_Service.php';

// Define the SOAP options.
$a_SoapOptions = array
	(
	'encoding'  => 'UTF-8',
	'exception' => True, // Turn SOAPFaults into Exceptions so PHP can report upon them.
	'trace'     => True, // Turn on tracing so we can see EXACTLY what the headers and request/response are.
	);

// As we are going to need to display XML, use Tidy to make it pretty.
$a_TidyConfig = array
	(
	'indent'            => 4,
	'indent-attributes' => true,
	'input-xml'         => true,
	'output-xml'        => true,
	'wrap'              => 0,
	);
$o_Tidy = new Tidy;

$s_WsdlUrl = "http://clients.mindbodyonline.com/api/0_5/AppointmentService.asmx?WSDL";

try
        {
       	// Create the service.
        $o_Service = new Appointment_x0020_Service($s_WsdlUrl, $a_SoapOptions);

	// Construct the parameter.
	// @todo - Go from hardcode to parameter.
	$o_Params = new GetScheduleItems;
	$o_Params->Request = new GetScheduleItemsRequest;
	$o_Params->Request->LocationIDs = array(1,2,3); // ArrayOfInt
	$o_Params->Request->StaffIDs = array(100,200,300); // ArrayOfLong
	$o_Params->Request->StartDate = '2011-01-01T00:00:00Z'; // dateTime
	$o_Params->Request->EndDate = '2011-12-31T23:59:59Z'; // dateTime

	// Call the method.
	// @todo - Go from hardcode to parameter.
        $o_Response = $o_Service->GetScheduleItems($o_Params);
        
	// Display the results.
	echo PHP_EOL,        
		// Show trace.
		'Request Headers', PHP_EOL,
		'---------------', PHP_EOL,
		$o_Service->__getLastRequestHeaders(), PHP_EOL,

		'Request (XML)', PHP_EOL,
		'-------------', PHP_EOL,
		$o_Tidy->repairString($o_Service->__getLastRequest(), $a_TidyConfig), PHP_EOL, PHP_EOL,

		'Response Headers', PHP_EOL,
		'----------------', PHP_EOL,
		$o_Service->__getLastResponseHeaders(), PHP_EOL,

		'Response (XML)', PHP_EOL,
		'--------------', PHP_EOL,
		$o_Tidy->repairString($o_Service->__getLastResponse(), $a_TidyConfig), PHP_EOL, PHP_EOL, PHP_EOL,

		'Response (Interpreted)', PHP_EOL,
		'----------------------', PHP_EOL,
		print_r($o_Response->GetScheduleItemsResult, True), PHP_EOL;

        }
catch(Exception $e)
	{
	echo PHP_EOL,

		// Show trace.
		'Request Headers', PHP_EOL,
		'---------------', PHP_EOL,
		$o_Service->__getLastRequestHeaders(), PHP_EOL,

		'Request (XML)', PHP_EOL,
		'-------------', PHP_EOL,
		$o_Tidy->repairString($o_Service->__getLastRequest(), $a_TidyConfig), PHP_EOL, PHP_EOL,

		'Response Headers', PHP_EOL,
		'----------------', PHP_EOL,
		$o_Service->__getLastResponseHeaders(), PHP_EOL,

		'Response (XML)', PHP_EOL,
		'--------------', PHP_EOL,
		$o_Tidy->repairString($o_Service->__getLastResponse(), $a_TidyConfig), PHP_EOL, PHP_EOL, PHP_EOL,

		// Show exception.
		'Exception', PHP_EOL,
		'---------', PHP_EOL,
		$e->getMessage(), PHP_EOL;
	}
